.386
.model flat,stdcall
option casemap:none

include test.inc

.data

FileToRead  db 'read.txt',0
FileToWrite db 'write.txt',0
text        db 'This is a test.'
ReadError   db 'cannot read the source file, error code %d',0
WriteError  db 'cannot write the destination file',0

.data?
pMemInfo    READFILE_MEMINFO <?>
buffer      db 100 dup(?)

.code

start:

    mov     esi,OFFSET pMemInfo
    invoke  ReadFileToMem,ADDR FileToRead,esi
    test    eax,eax
    jz      @f
    invoke  wsprintf,ADDR buffer,ADDR ReadError,eax
    invoke  StdOut,ADDR buffer
    jmp     finish
@@:
    invoke  StdOut,READFILE_MEMINFO.hMem[esi]
    invoke  FreeMemory,esi
    invoke  WriteFileToDisc,ADDR FileToWrite,ADDR text,NUMB_OF_BYTES_TO_WRITE
    test    eax,eax
    jnz     finish
    invoke  StdOut,ADDR WriteError

finish:

    invoke  ExitProcess,0
    
END start