.386
.model flat,stdcall
option casemap:none

include filefunc.inc

PUBLIC  WriteFileToDisc@12

.code

;   WriteFileToDisc PROC pFileName:DWORD,pMemory:DWORD,nSize:DWORD

;   pFileName       :   pointer to name of the file
;   pMemory         :   address of buffer to write file
;   nSize           :   number of bytes to write

;   Return values   :   if the function succeeds, eax is non-NULL
;                   :   if the function fails, the return value is NULL    


WriteFileToDisc@12:

    sub     esp,2*4                 ; reserve 8 bytes for the local variables
    invoke  CreateFile,DWORD PTR [esp+36],GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
    cmp     eax,INVALID_HANDLE_VALUE
    jne     @f
    xor     eax,eax
    jmp     finish
@@:
    mov     DWORD PTR [esp],eax     ; save the handle of file
    lea     ecx,DWORD PTR [esp+4]   ; get the address of number of bytes written
    invoke  WriteFile,eax,DWORD PTR [esp+28],DWORD PTR [esp+28],ecx,0
    test    eax,eax
    jz      finish
    invoke  CloseHandle,DWORD PTR [esp]

finish:

    add     esp,2*4                 ; balance the stack
    ret     3*4

;   ENDP WriteFileToDisc

END
